/*
 *  include/linux/faudit.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef __FAUDIT_H_
#define __FAUDIT_H_

#include <linux/config.h>
#include <linux/virtinfo.h>

struct vfsmount;
struct dentry;
struct super_block;
struct kstatfs;
struct kstat;
struct pt_regs;

struct faudit_regs_arg {
	int err;
	struct pt_regs *regs;
};

struct faudit_stat_arg {
	int err;
	struct vfsmount *mnt;
	struct dentry *dentry;
	struct kstat *stat;
};

struct faudit_stat64_arg {
	int err;
	struct vfsmount *mnt;
	struct dentry *dentry;
	struct kstat64 *stat;
};

struct faudit_statfs_arg {
	int err;
	struct super_block *sb;
	struct kstatfs *stat;
};

#define VIRTINFO_FAUDIT			(0)
#define VIRTINFO_FAUDIT_EXIT		(VIRTINFO_FAUDIT + 0)
#define VIRTINFO_FAUDIT_FORK		(VIRTINFO_FAUDIT + 1)
#define VIRTINFO_FAUDIT_CLONE		(VIRTINFO_FAUDIT + 2)
#define VIRTINFO_FAUDIT_VFORK		(VIRTINFO_FAUDIT + 3)
#define VIRTINFO_FAUDIT_EXECVE		(VIRTINFO_FAUDIT + 4)
#define VIRTINFO_FAUDIT_STAT		(VIRTINFO_FAUDIT + 5)
#define VIRTINFO_FAUDIT_STATFS		(VIRTINFO_FAUDIT + 6)
#define VIRTINFO_FAUDIT_STAT64		(VIRTINFO_FAUDIT + 7)

#endif
