/*
 *  include/linux/ve_task.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef __VE_TASK_H__
#define __VE_TASK_H__

#include <linux/seqlock.h>

struct ve_task_info {
/* virtualization */
	struct ve_struct *owner_env;
	struct ve_struct *exec_env;
	struct list_head vetask_list;
	struct dentry *glob_proc_dentry;
/* statistics: scheduling latency */
	cycles_t sleep_time;
	cycles_t sched_time;
	cycles_t sleep_stamp;
	cycles_t wakeup_stamp;
	seqcount_t wakeup_lock;
};

#define VE_TASK_INFO(task)	(&(task)->ve_task_info)
#define VE_TASK_LIST_2_TASK(lh)	\
	list_entry(lh, struct task_struct, ve_task_info.vetask_list)

#endif /* __VE_TASK_H__ */
