/*
 *  include/linux/vsched.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef __VSCHED_H__
#define __VSCHED_H__

#include <linux/config.h>
#include <linux/cache.h>
#include <linux/fairsched.h>
#include <linux/sched.h>

extern int vsched_create(int id, struct fairsched_node *node);
extern int vsched_destroy(struct vcpu_scheduler *vsched);

extern int vsched_mvpr(struct task_struct *p, struct vcpu_scheduler *vsched);
extern int vsched_set_vcpus(struct vcpu_scheduler *vsched, unsigned int vcpus);

extern int vcpu_online(int cpu);

#ifdef CONFIG_VE
#ifdef CONFIG_FAIRSCHED
extern unsigned long ve_scale_khz(unsigned long khz);
#else
#define ve_scale_khz(khz)	(khz)
#endif
#endif

#endif
